%%%%%%%%%%%%%%%%%%%%%%%% s15.pl %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 31.10.96
% Runs high number of processors and slackness
% Can be restarted (recompiled)
% Penalty routing until end
% Debugging option
% Scale goes now to 128
% Send protocols
% Graphical display of nonempty, attempts, and receive
% Multiple receivers
% PRAM modules

simulate(P,S,Proto,R,M) :- 
    showinputs(P,S,Proto,R,M),
    makeprocessors(P,S,R), 
    makeresults(P,S,R),
    route(P,S,Proto,R,M,1,Rnds), 
    showfinalstat(P,S,Proto,R,M,Rnds), 
    !.

makeprocessors(P,S,R) :-
% P=Processors, S=Slackness, R=Receivers
  for(I,1,P),
    dumpnl,dump(processor(I)),
    makeprocessor(P,S,R,I),
  fail.
makeprocessors(P,S,R) :- 
  call_tcl(update_log('\n')), !.

makeprocessor(P,S,R,I) :-
  makereceivers(P,S,R,I),
  makepackets(P,S,R,I),
  bb_def(I,0,size(R,S)),
  call_tcl(update_log('P')), !.

makereceivers(P,S,R,I) :-
  for(J,1,R),
    bb_def(I,J,rec(0,0)),
  fail.
makereceivers(_,_,_,_) :- !.

makepackets(P,S,R,I) :-
  S1 is R+1,SR is S+R,       
  for(K,S1,SR),
    random(1,P,X),
    dump(pak(X,0)),
    bb_def(I,K,pak(X,0)),
  fail.       
makepackets(P,S,R,I) :- !.

makeresults(P,S,R) :-
  bb_def(packet,0,0), bb_def(packet,1,0), bb_def(packet,high,1),
  bb_def(result,nonempty,0), bb_def(result,tried,0), bb_def(result,received,0),
  All is P*S, bb_def(result,unsent,All). %Total of unsent packets
 
route(P,S,Proto,R,M,Rnd,Rnds) :- 
  bb_val(result,unsent,U), U>0, !,
  dump(startround(Rnd)),dumpnl,
  call_tcl(update_log('Round=')),
  call_tcl(update_log(Rnd)),
  routingstep(P,Proto,M),
  showroundstat(P), 
  showprocessors(P,S,R),
  cleanreceivers(P,R),
  Rnd1 is Rnd+1, !,
  route(P,S,Proto,R,M,Rnd1,Rnds).
route(P,S,Proto,R,M,Rnd,Rnd) :- 
  cleanreceivers(P,R), !.

cleanreceivers(P,R) :- % wrong!
  dump(cleaningreceivers),dumpnl,
  for(I,1,P),
    cleanprocessor(P,R,I),
  fail.
cleanreceivers(_,_) :-
  dump(cleanedreceivers),dumpnl,
  bb_set(result,nonempty,0),
  bb_set(result,tried,0),
  bb_set(result,received,0).

cleanprocessor(P,R,I) :-
  for(J,1,R),
   dump(gettingbbval(I,J)),
    bb_val(I,J,rec(S,F)), 
    resetreceiver(I,J,S,F),
  fail.
cleanprocessor(P,R,I) :- !.
  
resetreceiver(I,J,S,F):- S>0, !,
  bb_set(I,J,rec(0,0)),
  dump(cleaned(adr(I,J),cont(S,F))),dumpnl,
  countfail(F), 
  !.
resetreceiver(I,J,0,F):- !,
  bb_set(I,J,rec(0,0)),
  dump(cleaned(adr(I,J),F,hits)),dumpnl.
  
routingstep(P,Proto,M) :-
  for(I,1,P),
    routepacket(P,Proto,M,I),    
  fail.
routingstep(P,Proto,M) :- !.

routepacket(P,Proto,M,I) :-
  bb_val(I,0,size(R,N)), N>0, !, % something to route
 dump(startroutepacket(I,has,N,packets)), dumpnl,
  bb_val(result,nonempty,NE), NE1 is NE+1, bb_set(result,nonempty,NE1), 
  N1 is R+1, N2 is R+N,
  random(N1,N2,J),
  bb_val(I,J,pak(T,F)), 
  dump(callsend(source(I,J),packet(T,F))), dumpnl,
  M1 is (T-1) mod M, random(1,M,M2), T1 is T-M1+M2-1, % random adr in module
  send(P,Proto,R,I,J,T1,F),
  !.
routepacket(P,Proto,M,I) :- !,
  dump(startroutepacket(hasnopacket,I)), dumpnl.

send(P,Proto,R,I,J,T,F) :-
  protocol(Proto,P,F),
  bb_val(result,tried,Tr), Tr1 is Tr+1, bb_set(result,tried,Tr1),
  random(1,R,K), bb_val(T,K,rec(SR,FR)),
 dump(callreceive(sender(I,J),packet(T,F),receiver(T,K),cont(SR,FR))), dumpnl,
  receive(I,J,T,F,K,SR,FR).
send(P,Proto,R,I,J,T,F) :- !, 
 dump(nocallreceive(sender(I,J),packet(T,F))), dumpnl.

protocol(greedy,P,F) :- !.
protocol(log,P,0) :- !.
protocol(log,P,1) :- !.
protocol(log,P,2) :- !.
protocol(log,P,F) :- F>2, !,
  F3 is log(F), ceiling(F3,FF), random(1,FF,Prob), Prob<2.
protocol(sqrt,P,0) :- !.
protocol(sqrt,P,1) :- !.
protocol(sqrt,P,F) :- F>1, !,
  sqrt(F,F2), ceiling(F2,FF), random(1,FF,Prob), Prob<2.
protocol(lin,P,0) :- !.
protocol(lin,P,1) :- !.
protocol(lin,P,F) :- F>1, !,
  random(1,F,Prob), Prob<2.
protocol(flogp,P,F) :- !,
  F1 is F+1, F2 is log(P), ceiling(F2,F3), min(F1,F3,FF),
  random(1,FF,Prob), Prob<2.
protocol(flogf,P,0) :- !.
protocol(flogf,P,1) :- !.
protocol(flogf,P,F) :- F>=2, !,
  F1 is F*log(F), ceiling(F1,FF), random(1,FF,Prob), Prob<2.
protocol(square,P,0) :- !.
protocol(square,P,1) :- !.
protocol(square,P,F) :- !, F>1, 
  FF is F*F, random(1,FF,Prob), Prob<2.
protocol(exp,P,0) :- !.
protocol(exp,P,F) :- F>0, !,
  **(2,F,FF), random(1,FF,Prob), Prob<2.
 
receive(I,J,T,F,K,0,0) :- % receiver empty
  bb_val(I,0,size(R,N)), N1 is N-1, bb_set(I,0,size(R,N1)),
  RN is R+N, bb_val(I,RN,Pkt), bb_set(I,J,Pkt),
  bb_set(T,K,rec(I,F)), 
  bb_val(result,received,X), X1 is X+1, bb_set(result,received,X1),
  dump(received(new,source(I,J),pak(T,F),recvr(T,K),rec(I,F))),dumpnl,
  !.
receive(I,J,T,F,K,SR,FR) :- SR>0, !, % receiver has a packet
  F1 is F+1, bb_set(I,J,pak(T,F1)),
  bb_val(SR,0,size(RR,NN)), NN1 is NN+1, bb_set(SR,0,size(RR,NN1)),
  FR1 is FR+1, RN1 is RR+NN+1, bb_set(SR,RN1,pak(T,FR1)),
  bb_set(T,K,rec(0,2)), 
  bb_val(result,received,X), X1 is X-1, bb_set(result,received,X1),
  dump(received(second,source(I,J),pak(T,F),recvr(T,K),pak(0,2))),dumpnl,
  !.
receive(I,J,T,F,K,0,FR) :- FR>0, !, % receiver has been target SR times
  F1 is F+1, bb_set(I,J,pak(T,F1)),
  FR1 is FR+1, bb_set(T,K,rec(0,FR1)),
  dump(received(many,source(I,J),pak(T,F),recvr(T,K),rec(0,FR1))),dumpnl,
  !.

showinputs(P,S,Proto,R,M) :- !,
  call_tcl(update_log('\nPRAM_simulation\n')),
  call_tcl(update_log('Processors=')), call_tcl(update_log(P)),
  call_tcl(update_log(',Slackness=')), call_tcl(update_log(S)),
  call_tcl(update_log(',Protocol=')),call_tcl(update_log(Proto)),
  call_tcl(update_log(',Receivers=')), call_tcl(update_log(R)),
  call_tcl(update_log('\n')),
  call_tcl(update_log('creating_processors\n')).

showroundstat(P) :-
dump(showroundstat),dumpnl,
  bb_val(result,nonempty,NE),
  bb_val(result,tried,Tr),
  bb_val(result,received,Re),
dump(got('***********',nonempty(NE),tried(Tr),received(Re),'********')),dumpnl,
  Y1 is ((100 * Re) // P), 
  Y2 is ((100 * Tr) // P), 
  Y3 is ((100 * NE) // P), 
  bb_val(result,unsent,U), U1 is U-Re, bb_set(result,unsent,U1),
  call_tcl(update_log('\ Nonempty=')),
  call_tcl(update_log(NE)),
  call_tcl(update_log('\ Tried=')),
  call_tcl(update_log(Tr)),
  call_tcl(update_log('\ Received=')),
  call_tcl(update_log(Re)),
  call_tcl(update_log('\ Remain=')),
  call_tcl(update_log(U1)),
  call_tcl(update_log('\n')),
  call_tcl(update_plot3(Y1,Y2,Y3)),
  !.

showfinalstat(P,S,Proto,R,M,Rnds) :-
  showfailures(FL),
  call_tcl(update_log('\nCost=')),
  C0 is (Rnds-1)/S, C1 is 100*C0, round(C1,C2), 
  C3 is C2 // 100, C4 is C2 mod 100,
  call_tcl(update_log(C3)),
  call_tcl(update_log('.')),
  call_tcl(update_log(C4)),
  call_tcl(update_log('\n')),
  system('mv loki loki.bak'), see('loki.bak'), tell(loki), 
  copylog, 
  write(result(proc(P),slack(S),proto(Proto),rec(R),mods(M),
  cost(C3,C4),fail(FL))), write('.'), nl, seen, told, !.
   
copylog :-
  read(T), T\=end_of_file, write(T), write('.'), nl, copylog.
copylog :- !.

countfail(I) :- bb_val(packet,I,N), !, 
  N1 is N+1, bb_set(packet,I,N1).
countfail(I) :- !, bb_def(packet,I,1), updatehigh(I).

updatehigh(N) :- bb_val(packet,high,M), M<N, !, 
  bb_set(packet,high,N).
updatehigh(_) :- !.

showfailures(FL) :-
  call_tcl(update_log('Collisions=')),
  bb_val(packet,high,High),
  listfailures(0,High,FL), !.
listfailures(I,High,[N*I|L]) :-
  I=<High, I1 is I+1,
  bb_val(packet,I,N),
  call_tcl(update_log(N)),
  call_tcl(update_log('*')),
  call_tcl(update_log(I)),
  call_tcl(update_log(',')),
  listfailures(I1,High,L).
listfailures(_,_,[]) :- !.

showprocessors(P,S,R) :-
  SR is S+R,
  for(I,1,P),
    for(J,0,SR), showreg(I,J), nl(J,SR), 
  fail.
showprocessors(_,_,_).
showreg(I,J) :- bb_val(I,J,X), dump(X), !.
showreg(I,J) :- dump(noval), !.
nl(I,J) :- I=J, dumpnl.
nl(_,_).

random(I,J,X) :- I<J, !,
  K is 1+J-I,
  random(Y),
%  pseudorandom(Y),
  X is I+(Y mod K).
random(I,I,I) :- !.

pseudorandom(X) :-
  bb_val(random,old,Y), !,
  Z is (683*Y) mod 714025, X is (Z+Z+150889) mod 714025,
  bb_set(random,old,X).

pseudorandom(X) :- !,
  X=797, bb_def(random,old,X).


min(X,Y,X) :- X=<Y, !.
min(X,Y,Y) :- X>Y, !.
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

dump(X) :- bb_val(dump,value,true), write(X), !.
dump(X) :- !.  
dumpnl :- bb_val(dump,value,true), nl, !.
dumpnl :- !.  

debugoff :-
  bb_val(dump,value,true), !, bb_set(dump,value,false).
debugoff :-
  bb_def(dump,value,false), !.
debugon :-
  bb_val(dump,value,false), !, bb_set(dump,value,true).
debugon :-
  bb_def(dump,value,true), !.

resetplot :- call_tcl(reset_plot), !.
updatesims(S) :- getval(S,V), call_tcl(update_log(V)), !.
getval(S,V) :- S<777, S=V, !.
getval(S,V) :- V=777, !.
